import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import * as i2 from 'devextreme-angular';
import { DxButtonModule, DxDataGridModule } from 'devextreme-angular';
import * as i3 from 'devextreme-angular/ui/nested';
import { TranslateModule, TranslateStore } from '@ngx-translate/core';
import { TranslateHttpLoader } from '@ngx-translate/http-loader';

class JdvEditorService {
    constructor() {
        this.addClickedEvent = new Subject();
        this.removeClickedEvent = new Subject();
        this.serviceDataSource = [];
    }
    serviceInit() {
        this.serviceDataSource.push({ id: 1, name: 'ser vice name', age: 666 });
    }
    serviceAddClicked(e) {
        this.addClickedEvent.next(e);
    }
    serviceRemoveClicked(e) {
        this.removeClickedEvent.next(e);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

//import { TranslateLoader, TranslateModule, TranslateModuleConfig, TranslatePipe, TranslateService, TranslateStore } from '@ngx-translate/core';
//import { HttpClient, provideHttpClient } from '@angular/common/http';
//import { TranslateHttpLoader } from '@ngx-translate/http-loader';
//import { bootstrapApplication } from '@angular/platform-browser';
// export function HttpLoaderFactory(httpClient: HttpClient) {
//   return new TranslateHttpLoader(httpClient, './assets/i18n/', '.json');
// }
class JdvEditorComponent {
    // @Inject('TRANSLATE_SERVICE') translateService: TranslateService
    constructor(jdvEditorService) {
        this.jdvEditorService = jdvEditorService;
        this.dataSource = [];
        this.addClickedEvent = new EventEmitter();
        this.removeClickedEvent = new EventEmitter();
        this.addClicked = this.addClicked.bind(this);
        this.removeClicked = this.removeClicked.bind(this);
        // translateService.get('jdvEditor.direct').subscribe(() => {
        //   alert('MAM');
        // });
    }
    addClicked(e) {
        this.addClickedEvent.emit(e);
    }
    removeClicked(e) {
        this.removeClickedEvent.emit(e);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorComponent, deps: [{ token: JdvEditorService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.13", type: JdvEditorComponent, selector: "lib-jdv-editor", inputs: { dataSource: "dataSource" }, outputs: { addClickedEvent: "addClickedEvent", removeClickedEvent: "removeClickedEvent" }, ngImport: i0, template: "<div id=\"jdv-editor\">\r\n  <div>\r\n    {{'jdvEditor.direct'}}\r\n    <div class=\"buttons-space\">\r\n      <dx-button icon=\"plus\" text=\"{{'jdvEditor.add'}}\" (onClick)=\"addClicked($event)\" />\r\n      <dx-button icon=\"minus\" text=\"{{'jdvEditor.remove'}}\" (onClick)=\"removeClicked($event)\" />\r\n    </div>\r\n\r\n    <div class=\"grid-square\">\r\n      <dx-data-grid [dataSource]=\"dataSource\">\r\n        <dxi-column dataField=\"id\"></dxi-column>\r\n        <dxi-column dataField=\"name\"></dxi-column>\r\n        <dxi-column dataField=\"age\"></dxi-column>\r\n      </dx-data-grid>\r\n    </div>\r\n  </div>\r\n\r\n  <div>\r\n    {{'jdvEditor.service'}}\r\n    <div class=\"grid-square\">\r\n      <dx-data-grid [dataSource]=\"jdvEditorService.serviceDataSource\">\r\n        <dxi-column dataField=\"id\"></dxi-column>\r\n        <dxi-column dataField=\"name\"></dxi-column>\r\n        <dxi-column dataField=\"age\"></dxi-column>\r\n      </dx-data-grid>\r\n    </div>\r\n\r\n    <div class=\"buttons-space\">\r\n      <dx-button icon=\"plus\" text=\"{{'jdvEditor.add'}}\" (onClick)=\"jdvEditorService.serviceAddClicked($event)\" />\r\n      <dx-button icon=\"minus\" text=\"{{'jdvEditor.remove'}}\" (onClick)=\"jdvEditorService.serviceRemoveClicked($event)\" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<!-- \r\n{{'jdvEditor.add' | translate}} \r\n{{'jdvEditor.remove' | translate}}\r\n{{'jdvEditor.direct' | translate}}\r\n{{'jdvEditor.service' | translate}}\r\n-->", styles: ["#jdv-editor{width:100%;height:100%}#jdv-editor .buttons-space{width:400px;display:flex;justify-content:space-between}#jdv-editor .grid-square{width:400px;height:400px}#jdv-editor .part{width:45%}\n"], dependencies: [{ kind: "component", type: i2.DxButtonComponent, selector: "dx-button", inputs: ["accessKey", "activeStateEnabled", "disabled", "elementAttr", "focusStateEnabled", "height", "hint", "hoverStateEnabled", "icon", "rtlEnabled", "stylingMode", "tabIndex", "template", "text", "type", "useSubmitBehavior", "validationGroup", "visible", "width"], outputs: ["onClick", "onContentReady", "onDisposing", "onInitialized", "onOptionChanged", "accessKeyChange", "activeStateEnabledChange", "disabledChange", "elementAttrChange", "focusStateEnabledChange", "heightChange", "hintChange", "hoverStateEnabledChange", "iconChange", "rtlEnabledChange", "stylingModeChange", "tabIndexChange", "templateChange", "textChange", "typeChange", "useSubmitBehaviorChange", "validationGroupChange", "visibleChange", "widthChange"] }, { kind: "component", type: i2.DxDataGridComponent, selector: "dx-data-grid", inputs: ["accessKey", "activeStateEnabled", "allowColumnReordering", "allowColumnResizing", "autoNavigateToFocusedRow", "cacheEnabled", "cellHintEnabled", "columnAutoWidth", "columnChooser", "columnFixing", "columnHidingEnabled", "columnMinWidth", "columnResizingMode", "columns", "columnWidth", "customizeColumns", "dataRowTemplate", "dataSource", "dateSerializationFormat", "disabled", "editing", "elementAttr", "errorRowEnabled", "export", "filterBuilder", "filterBuilderPopup", "filterPanel", "filterRow", "filterSyncEnabled", "filterValue", "focusedColumnIndex", "focusedRowEnabled", "focusedRowIndex", "focusedRowKey", "grouping", "groupPanel", "headerFilter", "height", "highlightChanges", "hint", "hoverStateEnabled", "keyboardNavigation", "keyExpr", "loadPanel", "masterDetail", "noDataText", "pager", "paging", "remoteOperations", "renderAsync", "repaintChangesOnly", "rowAlternationEnabled", "rowDragging", "rowTemplate", "rtlEnabled", "scrolling", "searchPanel", "selectedRowKeys", "selection", "selectionFilter", "showBorders", "showColumnHeaders", "showColumnLines", "showRowLines", "sortByGroupSummaryInfo", "sorting", "stateStoring", "summary", "syncLookupFilterValues", "tabIndex", "toolbar", "twoWayBindingEnabled", "visible", "width", "wordWrapEnabled"], outputs: ["onAdaptiveDetailRowPreparing", "onCellClick", "onCellDblClick", "onCellHoverChanged", "onCellPrepared", "onContentReady", "onContextMenuPreparing", "onDataErrorOccurred", "onDisposing", "onEditCanceled", "onEditCanceling", "onEditingStart", "onEditorPrepared", "onEditorPreparing", "onExporting", "onFocusedCellChanged", "onFocusedCellChanging", "onFocusedRowChanged", "onFocusedRowChanging", "onInitialized", "onInitNewRow", "onKeyDown", "onOptionChanged", "onRowClick", "onRowCollapsed", "onRowCollapsing", "onRowDblClick", "onRowExpanded", "onRowExpanding", "onRowInserted", "onRowInserting", "onRowPrepared", "onRowRemoved", "onRowRemoving", "onRowUpdated", "onRowUpdating", "onRowValidating", "onSaved", "onSaving", "onSelectionChanged", "onToolbarPreparing", "accessKeyChange", "activeStateEnabledChange", "allowColumnReorderingChange", "allowColumnResizingChange", "autoNavigateToFocusedRowChange", "cacheEnabledChange", "cellHintEnabledChange", "columnAutoWidthChange", "columnChooserChange", "columnFixingChange", "columnHidingEnabledChange", "columnMinWidthChange", "columnResizingModeChange", "columnsChange", "columnWidthChange", "customizeColumnsChange", "dataRowTemplateChange", "dataSourceChange", "dateSerializationFormatChange", "disabledChange", "editingChange", "elementAttrChange", "errorRowEnabledChange", "exportChange", "filterBuilderChange", "filterBuilderPopupChange", "filterPanelChange", "filterRowChange", "filterSyncEnabledChange", "filterValueChange", "focusedColumnIndexChange", "focusedRowEnabledChange", "focusedRowIndexChange", "focusedRowKeyChange", "groupingChange", "groupPanelChange", "headerFilterChange", "heightChange", "highlightChangesChange", "hintChange", "hoverStateEnabledChange", "keyboardNavigationChange", "keyExprChange", "loadPanelChange", "masterDetailChange", "noDataTextChange", "pagerChange", "pagingChange", "remoteOperationsChange", "renderAsyncChange", "repaintChangesOnlyChange", "rowAlternationEnabledChange", "rowDraggingChange", "rowTemplateChange", "rtlEnabledChange", "scrollingChange", "searchPanelChange", "selectedRowKeysChange", "selectionChange", "selectionFilterChange", "showBordersChange", "showColumnHeadersChange", "showColumnLinesChange", "showRowLinesChange", "sortByGroupSummaryInfoChange", "sortingChange", "stateStoringChange", "summaryChange", "syncLookupFilterValuesChange", "tabIndexChange", "toolbarChange", "twoWayBindingEnabledChange", "visibleChange", "widthChange", "wordWrapEnabledChange"] }, { kind: "component", type: i3.DxiColumnComponent, selector: "dxi-column", inputs: ["alignment", "allowEditing", "allowExporting", "allowFiltering", "allowFixing", "allowGrouping", "allowHeaderFiltering", "allowHiding", "allowReordering", "allowResizing", "allowSearch", "allowSorting", "autoExpandGroup", "buttons", "calculateCellValue", "calculateDisplayValue", "calculateFilterExpression", "calculateGroupValue", "calculateSortValue", "caption", "cellTemplate", "columns", "cssClass", "customizeText", "dataField", "dataType", "editCellTemplate", "editorOptions", "encodeHtml", "falseText", "filterOperations", "filterType", "filterValue", "filterValues", "fixed", "fixedPosition", "format", "formItem", "groupCellTemplate", "groupIndex", "headerCellTemplate", "headerFilter", "hidingPriority", "isBand", "lookup", "minWidth", "name", "ownerBand", "renderAsync", "selectedFilterOperation", "setCellValue", "showEditorAlways", "showInColumnChooser", "showWhenGrouped", "sortIndex", "sortingMethod", "sortOrder", "trueText", "type", "validationRules", "visible", "visibleIndex", "width"], outputs: ["filterValueChange", "filterValuesChange", "groupIndexChange", "selectedFilterOperationChange", "sortIndexChange", "sortOrderChange", "visibleChange", "visibleIndexChange"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-jdv-editor', template: "<div id=\"jdv-editor\">\r\n  <div>\r\n    {{'jdvEditor.direct'}}\r\n    <div class=\"buttons-space\">\r\n      <dx-button icon=\"plus\" text=\"{{'jdvEditor.add'}}\" (onClick)=\"addClicked($event)\" />\r\n      <dx-button icon=\"minus\" text=\"{{'jdvEditor.remove'}}\" (onClick)=\"removeClicked($event)\" />\r\n    </div>\r\n\r\n    <div class=\"grid-square\">\r\n      <dx-data-grid [dataSource]=\"dataSource\">\r\n        <dxi-column dataField=\"id\"></dxi-column>\r\n        <dxi-column dataField=\"name\"></dxi-column>\r\n        <dxi-column dataField=\"age\"></dxi-column>\r\n      </dx-data-grid>\r\n    </div>\r\n  </div>\r\n\r\n  <div>\r\n    {{'jdvEditor.service'}}\r\n    <div class=\"grid-square\">\r\n      <dx-data-grid [dataSource]=\"jdvEditorService.serviceDataSource\">\r\n        <dxi-column dataField=\"id\"></dxi-column>\r\n        <dxi-column dataField=\"name\"></dxi-column>\r\n        <dxi-column dataField=\"age\"></dxi-column>\r\n      </dx-data-grid>\r\n    </div>\r\n\r\n    <div class=\"buttons-space\">\r\n      <dx-button icon=\"plus\" text=\"{{'jdvEditor.add'}}\" (onClick)=\"jdvEditorService.serviceAddClicked($event)\" />\r\n      <dx-button icon=\"minus\" text=\"{{'jdvEditor.remove'}}\" (onClick)=\"jdvEditorService.serviceRemoveClicked($event)\" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<!-- \r\n{{'jdvEditor.add' | translate}} \r\n{{'jdvEditor.remove' | translate}}\r\n{{'jdvEditor.direct' | translate}}\r\n{{'jdvEditor.service' | translate}}\r\n-->", styles: ["#jdv-editor{width:100%;height:100%}#jdv-editor .buttons-space{width:400px;display:flex;justify-content:space-between}#jdv-editor .grid-square{width:400px;height:400px}#jdv-editor .part{width:45%}\n"] }]
        }], ctorParameters: () => [{ type: JdvEditorService }], propDecorators: { dataSource: [{
                type: Input
            }], addClickedEvent: [{
                type: Output
            }], removeClickedEvent: [{
                type: Output
            }] } });

function HttpLoaderFactory(httpClient) {
    return new TranslateHttpLoader(httpClient, './assets/i18n/', '.json');
}
class JdvEditorModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorModule, declarations: [JdvEditorComponent], imports: [DxButtonModule,
            DxDataGridModule,
            TranslateModule
            // .forChild({
            //   loader: {
            //     provide: TranslateLoader,
            //     useFactory: HttpLoaderFactory,
            //     deps: [HttpClient]
            //   }
            // })
        ], exports: [JdvEditorComponent,
            TranslateModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorModule, providers: [
            JdvEditorService,
            TranslateStore
        ], imports: [DxButtonModule,
            DxDataGridModule,
            TranslateModule
            // .forChild({
            //   loader: {
            //     provide: TranslateLoader,
            //     useFactory: HttpLoaderFactory,
            //     deps: [HttpClient]
            //   }
            // })
            , TranslateModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: JdvEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        DxButtonModule,
                        DxDataGridModule,
                        TranslateModule
                        // .forChild({
                        //   loader: {
                        //     provide: TranslateLoader,
                        //     useFactory: HttpLoaderFactory,
                        //     deps: [HttpClient]
                        //   }
                        // })
                    ],
                    declarations: [
                        JdvEditorComponent
                    ],
                    providers: [
                        JdvEditorService,
                        TranslateStore
                    ],
                    exports: [
                        JdvEditorComponent,
                        TranslateModule
                    ]
                }]
        }] });

/*
 * Public API Surface of jdv-editor
 */
//export * from './lib/interfaces/dummy-row'; /*Could not resolve "./lib/interfaces/dummy-row" from "../../dist/jdv-editor/esm2022/public-api.mjs"*/

/**
 * Generated bundle index. Do not edit.
 */

export { HttpLoaderFactory, JdvEditorComponent, JdvEditorModule, JdvEditorService };
//# sourceMappingURL=jdv-editor.mjs.map
